Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mppini.F90
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mppini.F90	(revision 14675)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mppini.F90	(revision 14676)
@@ -503,224 +366,209 @@
  9404    FORMAT('           *  '   ,20('     ' ,i4,'   *   ') )
       ENDIF
-
-      ! just to save nono etc for all proc
-      ! warning ii*ij (zone) /= mpprank (processors)!
-      ! ioso = zone number, ii_noso = proc number
-      ii_noso(:) = -1
-      ii_nono(:) = -1
-      ii_noea(:) = -1
-      ii_nowe(:) = -1
-      DO jproc = 1, jpnij
-         ii = iin(jproc)
-         ij = ijn(jproc)
-         IF( 0 <= ioso(ii,ij) .AND. ioso(ii,ij) <= (jpni*jpnj-1) ) THEN
-            iiso = 1 + MOD( ioso(ii,ij) , jpni )
-            ijso = 1 +      ioso(ii,ij) / jpni
-            ii_noso(jproc) = ipproc(iiso,ijso)
-         ENDIF
-         IF( 0 <= iowe(ii,ij) .AND. iowe(ii,ij) <= (jpni*jpnj-1) ) THEN
-          iiwe = 1 + MOD( iowe(ii,ij) , jpni )
-          ijwe = 1 +      iowe(ii,ij) / jpni
-          ii_nowe(jproc) = ipproc(iiwe,ijwe)
-         ENDIF
-         IF( 0 <= ioea(ii,ij) .AND. ioea(ii,ij) <= (jpni*jpnj-1) ) THEN
-            iiea = 1 + MOD( ioea(ii,ij) , jpni )
-            ijea = 1 +      ioea(ii,ij) / jpni
-            ii_noea(jproc)= ipproc(iiea,ijea)
-         ENDIF
-         IF( 0 <= iono(ii,ij) .AND. iono(ii,ij) <= (jpni*jpnj-1) ) THEN
-            iino = 1 + MOD( iono(ii,ij) , jpni )
-            ijno = 1 +      iono(ii,ij) / jpni
-            ii_nono(jproc)= ipproc(iino,ijno)
-         ENDIF
-      END DO
-
-      ! 6. Change processor name
-      ! ------------------------
-      ii = iin(narea)
-      ij = ijn(narea)
-      !
-      jpi    = ijpi(ii,ij)
-!!$      Nis0  = iis0(ii,ij)
-!!$      Nie0  = iie0(ii,ij)
-      jpj    = ijpj(ii,ij)
-!!$      Njs0  = ijs0(ii,ij)
-!!$      Nje0  = ije0(ii,ij)
-      nbondi = ibondi(ii,ij)
-      nbondj = ibondj(ii,ij)
-      nimpp = iimppt(ii,ij)
-      njmpp = ijmppt(ii,ij)
-      jpk = jpkglo                              ! third dim
-
-      ! set default neighbours
-      noso = ii_noso(narea)
-      nowe = ii_nowe(narea)
-      noea = ii_noea(narea)
-      nono = ii_nono(narea)
-
-      nones = -1
-      nonws = -1
-      noses = -1
-      nosws = -1
-
-      noner = -1
-      nonwr = -1
-      noser = -1
-      noswr = -1
-
-      IF((nbondi .eq. -1) .or. (nbondi .eq. 0)) THEN ! east neighbour exists
-         IF(ibondj(iin(noea+1),ijn(noea+1)) .eq. 0) THEN
-            nones = ii_nono(noea+1)                  ! east neighbour has north and south neighbours
-            noses = ii_noso(noea+1)
-         ELSEIF(ibondj(iin(noea+1),ijn(noea+1)) .eq. -1) THEN
-            nones = ii_nono(noea+1)                  ! east neighbour has north neighbour
-         ELSEIF(ibondj(iin(noea+1),ijn(noea+1)) .eq. 1) THEN
-            noses = ii_noso(noea+1)                  ! east neighbour has south neighbour
-         END IF
-      END IF
-      IF((nbondi .eq. 1) .or. (nbondi .eq. 0)) THEN  ! west neighbour exists
-         IF(ibondj(iin(nowe+1),ijn(nowe+1)) .eq. 0) THEN
-            nonws = ii_nono(nowe+1)                  ! west neighbour has north and south neighbours
-            nosws = ii_noso(nowe+1)
-         ELSEIF(ibondj(iin(nowe+1),ijn(nowe+1)) .eq. -1) THEN
-            nonws = ii_nono(nowe+1)                  ! west neighbour has north neighbour
-         ELSEIF(ibondj(iin(nowe+1),ijn(nowe+1)) .eq. 1)  THEN
-            nosws = ii_noso(nowe+1)                  ! west neighbour has north neighbour
-         END IF
-      END IF
-
-      IF((nbondj .eq. -1) .or. (nbondj .eq. 0)) THEN ! north neighbour exists
-         IF(ibondi(iin(nono+1),ijn(nono+1)) .eq. 0) THEN
-            noner = ii_noea(nono+1)                  ! north neighbour has east and west neighbours
-            nonwr = ii_nowe(nono+1)
-         ELSEIF(ibondi(iin(nono+1),ijn(nono+1)) .eq. -1) THEN
-            noner = ii_noea(nono+1)                  ! north neighbour has east neighbour
-         ELSEIF(ibondi(iin(nono+1),ijn(nono+1)) .eq. 1) THEN
-            nonwr = ii_nowe(nono+1)                  ! north neighbour has west neighbour
-         END IF
-      END IF
-      IF((nbondj .eq. 1) .or. (nbondj .eq. 0)) THEN  ! south neighbour exists
-         IF(ibondi(iin(noso+1),ijn(noso+1)) .eq. 0) THEN
-            noser = ii_noea(noso+1)                  ! south neighbour has east and west neighbours
-            noswr = ii_nowe(noso+1)
-         ELSEIF(ibondi(iin(noso+1),ijn(noso+1)) .eq. -1) THEN
-            noser = ii_noea(noso+1)                  ! south neighbour has east neighbour
-         ELSEIF(ibondi(iin(noso+1),ijn(noso+1)) .eq. 1) THEN
-            noswr = ii_nowe(noso+1)                  ! south neighbour has west neighbour
-         END IF
-      END IF
-
-      !
-      CALL init_doloop                          ! set start/end indices of do-loop, depending on the halo width value (nn_hls)
-      !
-      jpim1 = jpi-1                             ! inner domain indices
-      jpjm1 = jpj-1                             !   "           "
-      jpkm1 = MAX( 1, jpk-1 )                   !   "           "
-      jpij  = jpi*jpj                           !  jpi x j
-      DO jproc = 1, jpnij
-         ii = iin(jproc)
-         ij = ijn(jproc)
-         jpiall (jproc) = ijpi(ii,ij)
-         nis0all(jproc) = iis0(ii,ij)
-         nie0all(jproc) = iie0(ii,ij)
-         jpjall (jproc) = ijpj(ii,ij)
-         njs0all(jproc) = ijs0(ii,ij)
-         nje0all(jproc) = ije0(ii,ij)
-         ibonit(jproc) = ibondi(ii,ij)
-         ibonjt(jproc) = ibondj(ii,ij)
-         nimppt(jproc) = iimppt(ii,ij)
-         njmppt(jproc) = ijmppt(ii,ij)
-      END DO
-
+      !
+      ! Store informations for the north pole folding communications
+      nfproc(:) = ipproc(:,jpnj)
+      nfimpp(:) = iimppt(:,jpnj)
+      nfjpi (:) =   ijpi(:,jpnj)
+      !
+      ! 3. Define Western, Eastern, Southern and Northern neighbors + corners in the subdomain grid reference
+      ! ------------------------------------------------------------------------------------------------------
+      !
+      ! note that North fold is has specific treatment for its MPI communications.
+      ! This must not be treated as a "usual" communication with a northern neighbor.
+      !    -> North fold processes have no Northern neighbor in the definition done bellow
+      !
+      llmpi_Iperio = jpni > 1 .AND. l_Iperio                         ! do i-periodicity with an MPI communication?
+      llmpi_Jperio = jpnj > 1 .AND. l_Jperio                         ! do j-periodicity with an MPI communication?
+      !
+      l_SelfPerio(1:2) = l_Iperio .AND. jpni == 1                    !  west,  east periodicity by itself
+      l_SelfPerio(3:4) = l_Jperio .AND. jpnj == 1                    ! south, north periodicity by itself
+      l_SelfPerio(5:8) = l_SelfPerio(jpwe) .AND. l_SelfPerio(jpso)   ! corners bi-periodicity by itself
+      !
+      ! define neighbors mapping (1/2): default definition: ignore if neighbours are land-only subdomains or not
+      DO jj = 1, jpnj
+         DO ji = 1, jpni
+            !
+            IF ( llisOce(ji,jj) ) THEN                     ! this subdomain has some ocean: it has neighbours
+               !
+               inum0 = ji - 1 + ( jj - 1 ) * jpni             ! index in the subdomains grid. start at 0
+               !
+               ! Is there a neighbor?
+               llnei(jpwe,ji,jj) = ji >   1  .OR. llmpi_Iperio           ! West  nei exists if not the first column or llmpi_Iperio
+               llnei(jpea,ji,jj) = ji < jpni .OR. llmpi_Iperio           ! East  nei exists if not the last  column or llmpi_Iperio
+               llnei(jpso,ji,jj) = jj >   1  .OR. llmpi_Jperio           ! South nei exists if not the first line   or llmpi_Jperio
+               llnei(jpno,ji,jj) = jj < jpnj .OR. llmpi_Jperio           ! North nei exists if not the last  line   or llmpi_Jperio
+               llnei(jpsw,ji,jj) = llnei(jpwe,ji,jj) .AND. llnei(jpso,ji,jj)   ! So-We nei exists if both South and West nei exist
+               llnei(jpse,ji,jj) = llnei(jpea,ji,jj) .AND. llnei(jpso,ji,jj)   ! So-Ea nei exists if both South and East nei exist
+               llnei(jpnw,ji,jj) = llnei(jpwe,ji,jj) .AND. llnei(jpno,ji,jj)   ! No-We nei exists if both North and West nei exist
+               llnei(jpne,ji,jj) = llnei(jpea,ji,jj) .AND. llnei(jpno,ji,jj)   ! No-Ea nei exists if both North and East nei exist
+               !
+               ! Which index (starting at 0) have neighbors in the subdomains grid?
+               IF( llnei(jpwe,ji,jj) )   inei(jpwe,ji,jj) =            inum0 -    1 + jpni        * COUNT( (/ ji ==    1 /) )
+               IF( llnei(jpea,ji,jj) )   inei(jpea,ji,jj) =            inum0 +    1 - jpni        * COUNT( (/ ji == jpni /) )
+               IF( llnei(jpso,ji,jj) )   inei(jpso,ji,jj) =            inum0 - jpni + jpni * jpnj * COUNT( (/ jj ==    1 /) )
+               IF( llnei(jpno,ji,jj) )   inei(jpno,ji,jj) =            inum0 + jpni - jpni * jpnj * COUNT( (/ jj == jpnj /) )
+               IF( llnei(jpsw,ji,jj) )   inei(jpsw,ji,jj) = inei(jpso,ji,jj) -    1 + jpni        * COUNT( (/ ji ==    1 /) )
+               IF( llnei(jpse,ji,jj) )   inei(jpse,ji,jj) = inei(jpso,ji,jj) +    1 - jpni        * COUNT( (/ ji == jpni /) )
+               IF( llnei(jpnw,ji,jj) )   inei(jpnw,ji,jj) = inei(jpno,ji,jj) -    1 + jpni        * COUNT( (/ ji ==    1 /) )
+               IF( llnei(jpne,ji,jj) )   inei(jpne,ji,jj) = inei(jpno,ji,jj) +    1 - jpni        * COUNT( (/ ji == jpni /) )
+               !
+            ELSE                                           ! land-only domain has no neighbour
+               llnei(:,ji,jj) = .FALSE.
+            ENDIF
+            !
+         END DO
+      END DO
+      !
+      ! define neighbors mapping (2/2): check if neighbours are not land-only subdomains
+      DO jj = 1, jpnj
+         DO ji = 1, jpni
+            DO jn = 1, 8
+               IF( llnei(jn,ji,jj) ) THEN   ! if a neighbour is existing -> this should not be a land-only domain
+                  ii = 1 + MOD( inei(jn,ji,jj) , jpni )
+                  ij = 1 +      inei(jn,ji,jj) / jpni
+                  llnei(jn,ji,jj) = llisOce( ii, ij )
+               ENDIF
+            END DO
+         END DO
+      END DO
+      !
+      ! update index of the neighbours in the subdomains grid
+      WHERE( .NOT. llnei )   inei = -1
+      !
       ! Save processor layout in ascii file
       IF (llwrtlay) THEN
          CALL ctl_opn( inum, 'layout.dat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE., narea )
-         WRITE(inum,'(a)') '   jpnij   jpimax  jpjmax    jpk  jpiglo  jpjglo'//&
-   &           ' ( local:    narea     jpi     jpj )'
-         WRITE(inum,'(6i8,a,3i8,a)') jpnij,jpimax,jpjmax,jpk,jpiglo,jpjglo,&
-   &           ' ( local: ',narea,jpi,jpj,' )'
-         WRITE(inum,'(a)') 'narea   jpi  jpj Nis0 Njs0 Nie0 Nje0 nimp njmp nono noso nowe noea nbondi nbondj '
-
-         DO jproc = 1, jpnij
-            WRITE(inum,'(13i5,2i7)')     jproc,  jpiall(jproc),  jpjall(jproc),   &
-               &                                nis0all(jproc), njs0all(jproc),   &
-               &                                nie0all(jproc), nje0all(jproc),   &
-               &                                nimppt (jproc), njmppt (jproc),   &
-               &                                ii_nono(jproc), ii_noso(jproc),   &
-               &                                ii_nowe(jproc), ii_noea(jproc),   &
-               &                                ibonit (jproc), ibonjt (jproc)
+         WRITE(inum,'(a)') '  jpnij jpimax jpjmax    jpk jpiglo jpjglo ( local:   narea    jpi    jpj )'
+         WRITE(inum,'(6i7,a,3i7,a)') jpnij,jpimax,jpjmax,jpk,jpiglo,jpjglo,' ( local: ',narea,jpi,jpj,' )'
+         WRITE(inum,*) 
+         WRITE(inum,       *) '------------------------------------'
+         WRITE(inum,'(a,i2)') ' Mapping of the default neighnourgs '
+         WRITE(inum,       *) '------------------------------------'
+         WRITE(inum,*) 
+         WRITE(inum,'(a)') '  rank    ii    ij   jpi   jpj nimpp njmpp mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
+         DO jp = 1, jpnij
+            ii = iin(jp)
+            ij = ijn(jp)
+            WRITE(inum,'(15i6)')  jp-1, ii, ij, ijpi(ii,ij), ijpj(ii,ij), iimppt(ii,ij), ijmppt(ii,ij), inei(:,ii,ij)
          END DO
-      END IF
-
-      !                          ! north fold parameter
-      ! Defined npolj, either 0, 3 , 4 , 5 , 6
-      ! In this case the important thing is that npolj /= 0
-      ! Because if we go through these line it is because jpni >1 and thus
-      ! we must use lbcnorthmpp, which tests only npolj =0 or npolj /= 0
-      npolj = 0
-      ij = ijn(narea)
-      IF( jperio == 3 .OR. jperio == 4 ) THEN
-         IF( ij == jpnj )   npolj = 3
-      ENDIF
-      IF( jperio == 5 .OR. jperio == 6 ) THEN
-         IF( ij == jpnj )   npolj = 5
-      ENDIF
+      ENDIF
+
+      !
+      ! 4. Define Western, Eastern, Southern and Northern neighbors + corners for each mpi process
+      ! ------------------------------------------------------------------------------------------
+      ! 
+      ! rewrite information from "subdomain grid" to mpi process list
+      ! Warning, for example:
+      !    position of the northern neighbor in the "subdomain grid"
+      !    position of the northern neighbor in the "mpi process list"
+      
+      ! default definition: no neighbors
+      impi(:,:) = -1   ! (starting at 0, -1 if no neighbourg)
+      
+      DO jp = 1, jpnij
+         ii = iin(jp)
+         ij = ijn(jp)
+         DO jn = 1, 8
+            IF( llnei(jn,ii,ij) ) THEN   ! must be tested as some land-domain can be kept to fit mppsize
+               ii2 = 1 + MOD( inei(jn,ii,ij) , jpni )
+               ij2 = 1 +      inei(jn,ii,ij) / jpni
+               impi(jn,jp) = ipproc( ii2, ij2 )
+            ENDIF
+         END DO
+      END DO
+
+      !
+      ! 4. keep information for the local process
+      ! -----------------------------------------
+      !
+      ! set default neighbours
+      mpinei(:) = impi(:,narea)
+      DO jh = 1, n_hlsmax
+         mpiSnei(jh,:) = impi(:,narea)   ! default definition
+         mpiRnei(jh,:) = impi(:,narea)
+      END DO
       !
       IF(lwp) THEN
          WRITE(numout,*)
          WRITE(numout,*) '   resulting internal parameters : '
-         WRITE(numout,*) '      narea  = ', narea
-         WRITE(numout,*) '      nowe   = ', nowe  , '   noea  =  ', noea
-         WRITE(numout,*) '      nono   = ', nono  , '   noso  =  ', noso
-         WRITE(numout,*) '      nbondi = ', nbondi
-         WRITE(numout,*) '      nbondj = ', nbondj
-         WRITE(numout,*) '      npolj  = ', npolj
-         WRITE(numout,*) '    l_Iperio = ', l_Iperio
-         WRITE(numout,*) '    l_Jperio = ', l_Jperio
-         WRITE(numout,*) '      nimpp  = ', nimpp
-         WRITE(numout,*) '      njmpp  = ', njmpp
-      ENDIF
-
+         WRITE(numout,*) '      narea = ', narea
+         WRITE(numout,*) '      mpi nei  west = ', mpinei(jpwe)  , '   mpi nei  east = ', mpinei(jpea)
+         WRITE(numout,*) '      mpi nei south = ', mpinei(jpso)  , '   mpi nei north = ', mpinei(jpno)
+         WRITE(numout,*) '      mpi nei so-we = ', mpinei(jpsw)  , '   mpi nei so-ea = ', mpinei(jpse)
+         WRITE(numout,*) '      mpi nei no-we = ', mpinei(jpnw)  , '   mpi nei no-ea = ', mpinei(jpne)
+      ENDIF
       !                          ! Prepare mpp north fold
-      IF( jperio >= 3 .AND. jperio <= 6 .AND. jpni > 1 ) THEN
+      !
+      llmpiNFold =          jpni  > 1 .AND. l_NFold   ! is the North fold done with an MPI communication?
+      l_IdoNFold = ijn(narea) == jpnj .AND. l_NFold   ! is this process doing North fold?
+      !
+      IF( llmpiNFold ) THEN
          CALL mpp_ini_north
          IF (lwp) THEN
             WRITE(numout,*)
             WRITE(numout,*) '   ==>>>   North fold boundary prepared for jpni >1'
-            ! additional prints in layout.dat
-         ENDIF
-         IF (llwrtlay) THEN
+         ENDIF
+         IF (llwrtlay) THEN      ! additional prints in layout.dat
             WRITE(inum,*)
             WRITE(inum,*)
-            WRITE(inum,*) 'number of subdomains located along the north fold : ', ndim_rank_north
+            WRITE(inum,*) 'Number of subdomains located along the north fold : ', ndim_rank_north
             WRITE(inum,*) 'Rank of the subdomains located along the north fold : ', ndim_rank_north
-            DO jproc = 1, ndim_rank_north, 5
-               WRITE(inum,*) nrank_north( jproc:MINVAL( (/jproc+4,ndim_rank_north/) ) )
+            DO jp = 1, ndim_rank_north, 5
+               WRITE(inum,*) nrank_north( jp:MINVAL( (/jp+4,ndim_rank_north/) ) )
             END DO
          ENDIF
-      ENDIF
-
-      !
-      CALL mpp_ini_nc        ! Initialize communicator for neighbourhood collective communications
-      !
-      CALL init_ioipsl       ! Prepare NetCDF output file (if necessary)
-      !
-      IF (( jperio >= 3 .AND. jperio <= 6 .AND. jpni > 1 ).AND.( ln_nnogather )) THEN
-         CALL init_nfdcom     ! northfold neighbour lists
-         IF (llwrtlay) THEN
-            WRITE(inum,*)
-            WRITE(inum,*)
-            WRITE(inum,*) 'north fold exchanges with explicit point-to-point messaging :'
-            WRITE(inum,*) 'nsndto : ', nsndto
-            WRITE(inum,*) 'isendto : ', isendto
-         ENDIF
-      ENDIF
+         IF ( l_IdoNFold .AND. ln_nnogather ) THEN
+            CALL init_nfdcom     ! northfold neighbour lists
+            IF (llwrtlay) THEN
+               WRITE(inum,*)
+               WRITE(inum,*) 'north fold exchanges with explicit point-to-point messaging :'
+               WRITE(inum,*) '   nsndto  : ', nsndto
+               WRITE(inum,*) '   isendto : ', isendto(1:nsndto)
+            ENDIF
+         ENDIF
+      ENDIF
+      !
+      CALL mpp_ini_nc(nn_hls)    ! Initialize communicator for neighbourhood collective communications
+      DO jh = 1, n_hlsmax
+         mpi_nc_com4(jh) = mpi_nc_com4(nn_hls)   ! default definition
+         mpi_nc_com8(jh) = mpi_nc_com8(nn_hls)
+      END DO
+      !
+      CALL init_excl_landpt      ! exclude exchanges which contain only land points
+      !
+      ! Save processor layout changes in ascii file
+      DO jh = 1, n_hlsmax    ! different halo size
+         DO ji = 1, 8
+            ichanged(16*(jh-1)  +ji) = COUNT( mpinei(ji:ji) /= mpiSnei(jh,ji:ji) )
+            ichanged(16*(jh-1)+8+ji) = COUNT( mpinei(ji:ji) /= mpiRnei(jh,ji:ji) )
+         END DO
+      END DO
+      CALL mpp_sum( "mpp_init", ichanged )   ! must be called by all processes
+      IF (llwrtlay) THEN
+         WRITE(inum,*) 
+         WRITE(inum,       *) '----------------------------------------------------------------------'
+         WRITE(inum,'(a,i2)') ' Mapping of the neighnourgs once excluding comm with only land points '
+         WRITE(inum,       *) '----------------------------------------------------------------------'
+         DO jh = 1, n_hlsmax    ! different halo size
+            WRITE(inum,*) 
+            WRITE(inum,'(a,i2)') 'halo size: ', jh
+            WRITE(inum,       *) '---------'
+            WRITE(inum,'(a)') '  rank    ii    ij mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
+            WRITE(inum,   '(11i6,a)')  narea-1, iin(narea), ijn(narea),   mpinei(:), ' <- Org'
+            WRITE(inum,'(18x,8i6,a,i1,a)')   mpiSnei(jh,:), ' <- Send ', COUNT( mpinei(:) /= mpiSnei(jh,:) ), ' modif'
+            WRITE(inum,'(18x,8i6,a,i1,a)')   mpiRnei(jh,:), ' <- Recv ', COUNT( mpinei(:) /= mpiRnei(jh,:) ), ' modif'
+            WRITE(inum,*) ' total changes among all mpi tasks:'
+            WRITE(inum,*) '       mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
+            WRITE(inum,'(a,8i6)') ' Send: ', ichanged(jh*16-15:jh*16-8)
+            WRITE(inum,'(a,8i6)') ' Recv: ', ichanged(jh*16 -7:jh*16  )
+         END DO
+      ENDIF
+      !
+      CALL init_ioipsl           ! Prepare NetCDF output file (if necessary)
       !
       IF (llwrtlay) CLOSE(inum)
       !
-      DEALLOCATE(iin, ijn, ii_nono, ii_noea, ii_noso, ii_nowe,    &
-         &       iimppt, ijmppt, ibondi, ibondj, ipproc, ipolj,   &
-         &       ijpi, ijpj, iie0, ije0, iis0, ijs0,              &
-         &       iono, ioea, ioso, iowe, llisoce)
+      DEALLOCATE(iin, ijn, iimppt, ijmppt, ijpi, ijpj, ipproc, inei, llnei, impi, llisOce)
       !
     END SUBROUTINE mpp_init
@@ -789,11 +637,11 @@
         CALL ctl_stop( 'STOP', ctmp1, ctmp2 )
       ENDIF
-      IF( jperio == 3 .OR. jperio == 4 .OR. jperio == 5 .OR. jperio == 6 ) THEN
+      IF( l_NFold ) THEN
          ! minimize the size of the last row to compensate for the north pole folding coast
-         IF( jperio == 3 .OR. jperio == 4 )   ijpjmin = 2+3*khls   ! V and F folding must be outside of southern halos
-         IF( jperio == 5 .OR. jperio == 6 )   ijpjmin = 1+3*khls   ! V and F folding must be outside of southern halos
-         irm = knbj - irestj                                       ! total number of lines to be removed
-         klcj(:,knbj) = MAX( ijpjmin, kjmax-irm )                  ! we must have jpj >= ijpjmin in the last row
-         irm = irm - ( kjmax - klcj(1,knbj) )                      ! remaining number of lines to remove
+         IF( c_NFtype == 'T' )   ijpjmin = 2+3*khls   ! V and F folding must be outside of southern halos
+         IF( c_NFtype == 'F' )   ijpjmin = 1+3*khls   ! V and F folding must be outside of southern halos
+         irm = knbj - irestj                          ! total number of lines to be removed
+         klcj(:,knbj) = MAX( ijpjmin, kjmax-irm )     ! we must have jpj >= ijpjmin in the last row
+         irm = irm - ( kjmax - klcj(1,knbj) )         ! remaining number of lines to remove
          irestj = knbj - 1 - irm
          klcj(:, irestj+1:knbj-1) = kjmax-1
@@ -860,5 +708,5 @@
       LOGICAL :: llist
       LOGICAL, DIMENSION(:,:), ALLOCATABLE :: llmsk2d                 ! max size of the subdomains along i,j
-      LOGICAL, DIMENSION(:,:), ALLOCATABLE :: llisoce              !  -     -
+      LOGICAL, DIMENSION(:,:), ALLOCATABLE :: llisOce              !  -     -
       REAL(wp)::   zpropland
       !!----------------------------------------------------------------------
@@ -883,6 +731,6 @@
       iszimin = 4*nn_hls          ! minimum size of the MPI subdomain so halos are always adressing neighbor inner domain
       iszjmin = 4*nn_hls
-      IF( jperio == 3 .OR. jperio == 4 )   iszjmin = MAX(iszjmin, 2+3*nn_hls)   ! V and F folding must be outside of southern halos
-      IF( jperio == 5 .OR. jperio == 6 )   iszjmin = MAX(iszjmin, 1+3*nn_hls)   ! V and F folding must be outside of southern halos
+      IF( c_NFtype == 'T' )   iszjmin = MAX(iszjmin, 2+3*nn_hls)   ! V and F folding must be outside of southern halos
+      IF( c_NFtype == 'F' )   iszjmin = MAX(iszjmin, 1+3*nn_hls)   ! V and F folding must be outside of southern halos
       !
       ! get the list of knbi that gives a smaller jpimax than knbi-1
@@ -933,5 +781,5 @@
                iszi1(ii) = iszi0(ji)
                iszj1(ii) = iszj0(jj)
-            END IF
+            ENDIF
          END DO
       END DO
@@ -989,15 +837,15 @@
             WRITE(numout,*) '  -----------------------------------------------------'
             WRITE(numout,*)
-         END IF
+         ENDIF
          ji = isz0   ! initialization with the largest value
-         ALLOCATE( llisoce(inbi0(ji), inbj0(ji)) )
-         CALL mpp_is_ocean( llisoce )   ! Warning: must be call by all cores (call mpp_sum)
-         inbijold = COUNT(llisoce)
-         DEALLOCATE( llisoce )
+         ALLOCATE( llisOce(inbi0(ji), inbj0(ji)) )
+         CALL mpp_is_ocean( llisOce )   ! Warning: must be call by all cores (call mpp_sum)
+         inbijold = COUNT(llisOce)
+         DEALLOCATE( llisOce )
          DO ji =isz0-1,1,-1
-            ALLOCATE( llisoce(inbi0(ji), inbj0(ji)) )
-            CALL mpp_is_ocean( llisoce )   ! Warning: must be call by all cores (call mpp_sum)
-            inbij = COUNT(llisoce)
-            DEALLOCATE( llisoce )
+            ALLOCATE( llisOce(inbi0(ji), inbj0(ji)) )
+            CALL mpp_is_ocean( llisOce )   ! Warning: must be call by all cores (call mpp_sum)
+            inbij = COUNT(llisOce)
+            DEALLOCATE( llisOce )
             IF(lwp .AND. inbij < inbijold) THEN
                WRITE(numout,'(a, i6, a, i6, a, f4.1, a, i9, a, i6, a, i6, a)')                                 &
@@ -1006,5 +854,5 @@
                   &   '%), largest oce domain: ', iszi0(ji)*iszj0(ji), ' ( ', iszi0(ji),' x ', iszj0(ji), ' )'
                inbijold = inbij
-            END IF
+            ENDIF
          END DO
          DEALLOCATE( inbi0, inbj0, iszi0, iszj0 )
@@ -1022,8 +870,8 @@
       DO WHILE( inbij > knbij )   ! while the number of ocean subdomains exceed the number of procs
          ii = ii -1
-         ALLOCATE( llisoce(inbi0(ii), inbj0(ii)) )
-         CALL mpp_is_ocean( llisoce )            ! must be done by all core
-         inbij = COUNT(llisoce)
-         DEALLOCATE( llisoce )
+         ALLOCATE( llisOce(inbi0(ii), inbj0(ii)) )
+         CALL mpp_is_ocean( llisOce )            ! must be done by all core
+         inbij = COUNT(llisOce)
+         DEALLOCATE( llisOce )
       END DO
       knbi = inbi0(ii)
@@ -1073,5 +921,5 @@
          !
          ALLOCATE( lloce(Ni0glo, ijsz) )                                     ! allocate the strip
-         CALL readbot_strip( ijstr, ijsz, lloce )
+         CALL read_mask( 1, ijstr, Ni0glo, ijsz, lloce )
          inboce = COUNT(lloce)                                               ! number of ocean point in the stripe
          DEALLOCATE(lloce)
@@ -1087,5 +935,5 @@
 
 
-   SUBROUTINE mpp_is_ocean( ldisoce )
+   SUBROUTINE mpp_is_ocean( ldIsOce )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE mpp_is_ocean  ***
@@ -1095,5 +943,5 @@
       !!              at least 1 ocean point.
       !!              We must indeed ensure that each subdomain that is a neighbour
-      !!              of a land subdomain as only land points on its boundary
+      !!              of a land subdomain, has only land points on its boundary
       !!              (inside the inner subdomain) with the land subdomain.
       !!              This is needed to get the proper bondary conditions on
@@ -1102,5 +950,5 @@
       !! ** Method  : read inbj strips (of length Ni0glo) of the land-sea mask
       !!----------------------------------------------------------------------
-      LOGICAL, DIMENSION(:,:), INTENT(  out) ::   ldisoce        ! .true. if a sub domain constains 1 ocean point
+      LOGICAL, DIMENSION(:,:), INTENT(  out) ::   ldIsOce        ! .true. if a sub domain constains 1 ocean point
       !
       INTEGER :: idiv, iimax, ijmax, iarea
@@ -1115,10 +963,10 @@
       ! do nothing if there is no land-sea mask
       IF( numbot == -1 .AND. numbdy == -1 ) THEN
-         ldisoce(:,:) = .TRUE.
+         ldIsOce(:,:) = .TRUE.
          RETURN
       ENDIF
       !
-      inbi = SIZE( ldisoce, dim = 1 )
-      inbj = SIZE( ldisoce, dim = 2 )
+      inbi = SIZE( ldIsOce, dim = 1 )
+      inbj = SIZE( ldIsOce, dim = 2 )
       !
       ! we want to read inbj strips of the land-sea mask. -> pick up inbj processes every idiv processes starting at 1
@@ -1143,9 +991,9 @@
             inry = iny - COUNT( (/ iarea == 1, iarea == inbj /) )      ! number of point to read in y-direction
             isty = 1 + COUNT( (/ iarea == 1 /) )                       ! read from the first or the second line?
-            CALL readbot_strip( ijmppt(1,iarea) - 2 + isty, inry, lloce(2:inx-1, isty:inry+isty-1) )   ! read the strip
+            CALL read_mask( 1, ijmppt(1,iarea) - 2 + isty, Ni0glo, inry, lloce(2:inx-1, isty:inry+isty-1) )   ! read the strip
             !
             IF( iarea == 1    ) THEN                                   ! the first line was not read
-               IF( jperio == 2 .OR. jperio == 7 ) THEN                 !   north-south periodocity
-                  CALL readbot_strip( Nj0glo, 1, lloce(2:inx-1, 1) )   !   read the last line -> first line of lloce
+               IF( l_Jperio ) THEN                                     !   north-south periodocity
+                  CALL read_mask( 1, Nj0glo, Ni0glo, 1, lloce(2:inx-1, 1) )   !   read the last line -> first line of lloce
                ELSE
                   lloce(2:inx-1,  1) = .FALSE.                         !   closed boundary
@@ -1153,7 +1001,7 @@
             ENDIF
             IF( iarea == inbj ) THEN                                   ! the last line was not read
-               IF( jperio == 2 .OR. jperio == 7 ) THEN                 !   north-south periodocity
-                  CALL readbot_strip( 1, 1, lloce(2:inx-1,iny) )       !      read the first line -> last line of lloce
-               ELSEIF( jperio == 3 .OR. jperio == 4 ) THEN             !   north-pole folding T-pivot, T-point
+               IF( l_Jperio ) THEN                                     !   north-south periodocity
+                  CALL read_mask( 1, 1, Ni0glo, 1, lloce(2:inx-1,iny) )   !      read the first line -> last line of lloce
+               ELSEIF( c_NFtype == 'T' ) THEN                          !   north-pole folding T-pivot, T-point
                   lloce(2,iny) = lloce(2,iny-2)                        !      here we have 1 halo (even if nn_hls>1)
                   DO ji = 3,inx-1
@@ -1163,5 +1011,5 @@
                      lloce(ji,iny-1) = lloce(inx-ji+2,iny-1)
                   END DO
-               ELSEIF( jperio == 5 .OR. jperio == 6 ) THEN             !   north-pole folding F-pivot, T-point, 1 halo
+               ELSEIF( c_NFtype == 'F' ) THEN                          !   north-pole folding F-pivot, T-point, 1 halo
                   lloce(inx/2+1,iny-1) = lloce(inx/2,iny-1)            !      here we have 1 halo (even if nn_hls>1)
                   lloce(inx  -1,iny-1) = lloce(2    ,iny-1)
@@ -1174,5 +1022,5 @@
             ENDIF
             !                                                          ! first and last column were not read
-            IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7 ) THEN
+            IF( l_Iperio ) THEN
                lloce(1,:) = lloce(inx-1,:)   ;   lloce(inx,:) = lloce(2,:)   ! east-west periodocity
             ELSE
@@ -1193,5 +1041,5 @@
       CALL mpp_sum( 'mppini', inboce_1d )
       inboce = RESHAPE(inboce_1d, (/inbi, inbj/))
-      ldisoce(:,:) = inboce(:,:) /= 0
+      ldIsOce(:,:) = inboce(:,:) /= 0
       DEALLOCATE(inboce, inboce_1d)
       !
@@ -1199,7 +1047,7 @@
 
 
-   SUBROUTINE readbot_strip( kjstr, kjcnt, ldoce )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE readbot_strip  ***
+   SUBROUTINE read_mask( kistr, kjstr, kicnt, kjcnt, ldoce )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE read_mask  ***
       !!
       !! ** Purpose : Read relevant bathymetric information in order to
